include "ZeroPage.inc"
include "Vram.inc"
include "VVram.inc"

ext VVram_
ext Chars_, Ascii_

VramTop equ Vram+VramRowSize*0
AsciiSize equ 6

dseg
Backup: defs VVramWidth*(VVramHeight-2)


pVram equ ZW0
pPattern equ ZW1
pVVram equ ZW2
pBackup equ ZW3
pFlags equ ZW4
yCount equ ZB0
xCount equ ZB1
flags equ ZB2
maskBit equ ZB3


dseg
PrintC_@Param0: public PrintC_@Param0
PrintC_pVram: 
Put_@Param0: public Put_@Param0
Put_pVram: 
    defw 0
PrintC_@Param1: public PrintC_@Param1
PrintC_c: 
Put_@Param1: public Put_@Param1
Put_c:
    defb 0

cseg
WaitBlank:
    do
        tim #$80,$02
    while ne | wend
rts


; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    psha
        ldaa #$aa
        ldx #Vram
        do
            staa 0,x | inx
            cpx #Vram+VramWidth*64
        while ne | wend
        
        ldx #Backup
        do
            clr 0,x | inx
            cpx #Backup+VVramWidth*VVramHeight
        while ne | wend
    pula
rts


; ptr<byte> Put(ptr<byte> pVram, byte c);
cseg
Put:
    ldab #3
    mul
    addd #Chars_
    std <pPattern

    ldab #3
    do
        pshb
            ldx <pPattern
            ldaa 0,x | inx
            stx <pPattern

            ldx <pVram | staa 0,x
            ldd <pVram | addd #VramWidth | std <pVram
        pulb
        decb
    while ne | wend
rts
Put_: public Put_
    psha | pshb
        ldx Put_pVram | stx <pVram
        ldaa Put_c 
        bsr Put
    pulb | pula
    ldx Put_pVram | inx
rts


; ptr<byte> PrintC(ptr<byte> address, byte c);
cseg
CharTable:
    defb " -0123456789ABCDEGHIMNOPRSTUVX"
PrintC_: public PrintC_
    psha | pshb
        ldx PrintC_pVram | stx <pVram

        ldaa PrintC_c
        clrb
        ldx #CharTable
        do
            cmpa 0,x
            beq PrintC_break
            incb
            inx
            cpx #CharTable+30
        while ne | wend
        clrb
        PrintC_break:
        ldaa #AsciiSize
        mul
        addd #Ascii_
        std <pPattern

        ldab #AsciiSize
        do
            pshb
                ldx <pPattern
                ldaa 0,x | inx
                stx <pPattern

                ldx <pVram | staa 0,x
                ldd <pVram
                addd #VramWidth
                std <pVram
            pulb
            decb
        while ne | wend
    pulb | pula
    ldx PrintC_pVram | inx
rts


; void VVramToVram();
VVramToVram_: public VVramToVram_
    psha | pshb
        ldx #VVram_ | stx <pVVram
        ldx #Backup | stx <pBackup
        ldx #VramTop | stx <pVram

        ldaa #VVramHeight | staa <yCount
        do
            ldaa #VVramWidth
            staa <xCount
            do
                ldx <pVVram | ldaa 0,x
                ldx <pBackup | cmpa 0,x
                if ne
                    staa 0,x
                    bsr Put
                    ldd <pVram | addd #-VramWidth*3+1 | std <pVram
                else
                    ldx <pVram | inx | stx <pVram
                endif

                ldx <pVVram | inx | stx <pVVram
                ldx <pBackup | inx | stx <pBackup
                
                dec <xCount
            while ne | wend

            ldd <pVram | addd #VramWidth*3-VVramWidth | std <pVram
            dec <yCount
        while ne | wend
    pulb | pula
rts
